/****************************************************************************
**
** Copyright (C) 2006-2008 fullmetalcoder <fullmetalcoder@hotmail.fr>
**
** This file is part of the Edyuk project <http://edyuk.org>
** 
** This file may be used under the terms of the GNU General Public License
** version 2 as published by the Free Software Foundation and appearing in the
** file GPL.txt included in the packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef _GENERATOR_H_
#define _GENERATOR_H_

#include <QtGlobal>

#include <QHash>

class QString;
class QByteArray;

class Action;
struct HashedAutomaton;

class Generator
{
	public:
		typedef QHash<QByteArray, quint16> TokenMap;
		
		struct Output
		{
			TokenMap tokenIdMap;
			
			QList<Action*> actions;
			
			HashedAutomaton *lexer;
			
			HashedAutomaton *parser;
		};
		
		Output create(const QString& lexerDef, const QString& parserDef) const;
		
		HashedAutomaton* createLexer(const QString& file, TokenMap& tokens) const;
		HashedAutomaton* createParser(const QString& file, const TokenMap& tokens, QList<Action*>& actions) const;
};

#endif // _GENERATOR_H_
